'''
dict 특징 
  - set 자료구조와 유사함
  형식) {'key':value, 'key':value, ...}
  - json 형식, R의 list 동일
  - key 접근만 가능함(index, value 사용 불가)
  - key 중복 불가 
  - 출력 순서 random
'''

# 1. 딕트 생성 

# 1) 방법1
dic = dict(key1 = 100, key2 = 200, key3 = 300)
print(dic) # {'key2': 200, 'key1': 100, 'key3': 300}

# 20 방법2
person = {'name':'홍길동', 'age': 35, 'address' : '서울시'}
print(person)
print( person['name']) # index : key

print(type(dic), type(person)) # <class 'dict'> <class 'dict'>

# 원소 수정, 삭제, 추가
# dict 원소 수정 
person['age'] = 45
print(person)

# dict 원소 삭제
del person['address']
print(person) # {'name': '홍길동', 'age': 45}

# dict 원소 추가 
person['pay'] = 350
print(person) # {'name': '홍길동', 'pay': 350, 'age': 45}


# 2. 요소 검사
print(person['age']) # 35
print('age' in person) # True

# 요소 반복
for key in person.keys() : # key 넘김 
    print(key) # key 출력 

for v in person.values() : # value 넘김 
    print(v) # value 출력  

for i in person.items() : # item 넘김 
    print(i) # ('name', '홍길동')


# 키로 값 가져오기 : get(key)
print( person['name']) # index 형식
print( person.get('name')) # get함수 -> 홍길동 

# 내용 지우기 obj.clear()
person.clear()
print(person) # {}


print('emp')
emp = {'hong' : 350, 'lee' : 450, 'kang' : 550}
print(emp)
print(emp['lee'])
print(emp.get('hong')) # 350

# dict 원소 수정 
emp['lee'] = 300
print(emp)

# dict 원소 제거 
del emp['hong']
print(emp) 

# dict 원소 추가 
emp['yoo'] = 250
print(emp) # {'lee': 300, 'kang': 550, 'yoo': 250}


if 'kang' in emp : 
    print('있음')
else : 
    print('없음')


for name, pay in emp.items():
    print(f"name : {name} => pay {pay}")
    
# 3. 문자 빈도수 구하기[1] 
charset = ['abc', 'code', 'band', 'band', 'abc']
wc = {}

# get() 함수 이용 단어 카운트
for key in charset :      
    wc[key] = wc.get(key, 0) + 1 # get() 이용 
print(wc)









