
'''
1. 람다함수(Lambda)
 - 한 줄 축약 함수
 형식) 변수 = lambda 인수 : 리턴값
 ex) lambda x,y : x+y

2. scope
  - 전역변수/지역변수
'''

# 1. 람다 함수(Lambda)

# (1) 일반함수
def Adder(x, y):
    add = x + y
    return add

print('add=', Adder(10, 20))

# (2) 람다 함수
print('add=', (lambda x, y: x + y)(10, 20))



# 2. scope : 전역변수/지역변수

# 전역변수 : 전 지역 사용
# 지역변수 : 함수 or 블럭(if, while, for) 사용

x = 50  # 전역변수


def local_func(x):
    x += 50  # 지역변수 -> 종료 시점 소멸


local_func(x)
print('x=', x)  # x= 50


def global_func():
    global x  # 전역변수 x 사용
    x += 50  # x+50 = 100


global_func()
print('x=', x)  # x= 100

data = [1, 3, 5, 7, 9]
tot = 0  # 전역변수


def calc_func(data):
    global tot  # tot=0
    for d in data:
        tot += d  # error  tot(null) = tot(null) + d(1)
    return tot


tot = calc_func(data)
print('tot=', tot)  # tot= 25


