'''
step04_csvFileIO_sampling

csv 파일 입출력 
 1. csv file read
 2. csv file write
 3. DataFrame random sample
'''

import pandas as pd # 별칭 
import os

os.chdir('C:/PythonStatistics/data')

# 1. csv 파일 읽기
'''
iris = pd.read_csv('iris.csv')
print(iris.info())

# 칼럼명 특수문자 or 공백 -> '_' 교체 
iris.columns = iris.columns.str.replace('.', '_')
print(iris.head())
'''

# 칼럼명이 없는 경우 
st = pd.read_csv('student.csv', header = None)
print(st) # 0     1    2   3

# 칼럼명 수정 
col_names = ['sno', 'name', 'height', 'weight']
st.columns = col_names
print(st)


# 2. 파생변수 추가 
# 비만도 지수(bmi) 칼럼 추가 : 정상체중(18~23)
# BMI = 몸무게 / 키² 
# 몸무게 단위 : kg, 키 단위 : m
# 키 단위 변경 : cm -> m

BMI = st['weight'] / (st['height']*0.01)**2  

print(BMI) # [21.224489795918366, 24.835646457268076, 20.04744562130375, 21.604938271604937]

# BMI 칼럼 추가 : 반올림 처리 
st['BMI'] = BMI.round(2) # 소숫점 2자리 
print(st)

# 비만도 레이블 추가: 18~23 정상체중 
labels = []
for i in st.BMI  :
    if i >= 18 and i <= 23 :
        labels.append("정상")
    elif i > 23:
        labels.append("비만")
    else :
        labels.append("저체중")

# 비만도 레이블 칼럼 추가     
st['labels'] = labels  
print(st)
  

# 3. csv 파일 저장 

# csv file 저장 
st.to_csv('st_info.csv', index=None, encoding='utf-8')
# csv file 읽기 
st = pd.read_csv('st_info.csv', encoding='utf-8')
print(st)


# 4. excel 파일 읽기 
# (1) 파일 읽기
import pandas as pd # 별칭 
import os

os.chdir('C:/PythonStatistics/data')
sam = pd.ExcelFile("sam_kospi.xlsx")

# (2) 파싱 
kospi = sam.parse("sam_kospi")
print(kospi.info())

# (3) 칼럼 추출 
high = kospi['High']
low = kospi['Low']

# (4) 평균 계산
print('High mean :', high.mean())
print('Low mean :', low.mean())










