# -*- coding: utf-8 -*-


import numpy as np # 별칭 


# 1. array() : 다차원 배열 생성 

# 1) 단일 list -> 1차원 배열 
lst1 = [3, 5.2, 4, 7, 6]
print(lst1) # 단일 리스트 배열 

# list -> array
arr1d = np.array(lst1) # array(단일list)
print(arr1d)
print(arr1d.shape) # 자료구조 확인

print('평균 =', arr1d.mean()) # 5.04
print('분산=', arr1d.var())#분산= 2.0063999999999997
print('표준편차=', arr1d.std())#표준편차= 1.4164744967700618 


# 2) 중첩list -> 2차원 배열 
lst2 = [[1,2,3,4,5], [6,7,8,9,10]]
print(lst2)

arr2d = np.array(lst2) # array(중첩list)
print(arr2d)
print(arr2d.shape) # (2, 5)


# 행렬 index : obj[행index, 열index]
print(arr2d[1, :]) # 2행 전체 
print(arr2d[1]) # 2행 전체 
print(arr2d[:, 2]) # 3열 전체
print(arr2d[:, 2:5]) # 2행 3열 

# 3) broadcast 연산 
# - 작은 차원이 큰 차원으로 늘어난 후 연산 
'''
모집단 분산 = sum((x-mu)**2) / n
표본 분산 = sum((x-mu)**2) / n-1
'''

mu = arr1d.mean() # 5.04
diff = (arr1d - mu)**2  # 1d - scala : 브로드케스트  
var = sum(diff) / len(arr1d)
print('분산 =', var) # 2.0063999999999997


# 1) scala(0) vs vector(1)
print(0.5 * arr1d)
# array([1.5, 2.6, 2. , 3.5, 3. ])

# 2) scala(0) vs matrix(2)
print(0.5 * arr2d)

# 3) vector(1) vs matrix(2)
print(arr1d * arr2d) # 1d(1,5) * 2d(2, 5)
'''
array([[ 3. , 10.4, 12. , 28. , 30. ],
       [18. , 36.4, 32. , 63. , 60. ]])
'''


# 3. zeros or ones 
zerr = np.zeros( (3, 5) ) # 3행5열 
print(zerr)
'''
[[0. 0. 0. 0. 0.]
 [0. 0. 0. 0. 0.]
 [0. 0. 0. 0. 0.]]
'''

onearr = np.ones( (3, 5) ) # 3행5열 
print(onearr)

# 4. arange : range(n), range(n,m), range(n,m,s)

# 1) range va arange
print(range(1, 11)) #  range(1, 11)
print(range(-1.0, 10.5)) # float 사용 불가 

arr = np.arange(-1.2, 5.5) # float 사용 가능, 배열 객체  
print(arr) # [-1.2 -0.2  0.8  1.8  2.8  3.8  4.8]

# 2) x의 수열에 대한 2차 방정식 
x = np.arange(-1.0, 2, 0.1)
y = x**2 + 2*x + 3
print(y)

# 2차 방정식 그래프 
import matplotlib.pyplot as plt
plt.plot(x, y)
plt.show()


# 3) 색인 반환 
cnt = 0
for i in np.arange(3) : # 행 index
    for j in np.arange(5) : # 열 index
        cnt += 1 # 카운터 변수 
        zerr[i, j] = cnt # 셀에 저장 
    

print(zerr)
'''
[[ 1.  2.  3.  4.  5.]
 [ 6.  7.  8.  9. 10.]
 [11. 12. 13. 14. 15.]]
'''













