

import numpy as np 

# 2. 행렬곱과 연립방정식 해


# 1) 행렬곱(내적)
a = np.array([[1,1],[0,1]])
print(a) 
'''
[[1 1]
 [0 1]]
'''

b = np.array([[2,3], [1,5]])
print(b)
'''
[[2 3]
 [1 5]]
'''

dot_re = a.dot(b)
print(dot_re)
'''
[[3 8]
 [1 5]]
'''

'''
행렬곱 연산 시 주의사항 
 1. A, B -> 행렬 구조 
 2. 수 일치 : A(열수) = B(행수)
'''

# 2) 행렬의 거듭제곱 
'''
A^2 = 1 2    1 2   7  10
      3 4  x 3 4 = 15 22    
'''


x = np.array([[1,2],[3,4]])
print(x @ x) # print(x.dot(x)) 
'''
[[ 7 10]
 [15 22]]
'''



# 3) 연립방정식 해(Solve a linear matrix equation): np.linalg.solve(a, b)
'''
연립방정식은 2개 이상의 방정식을 묶어놓은 것으로 
다음과 같은 연립방정식의 해(x, y)를 구하는 함수 이다.
3*x = 2*y = 53
-4*x + 3*y = -65
'''

a = np.array([[3, 2], [-4, 3]])
b = np.array([53, -65])
x, y = np.linalg.solve(a, b)
print('x =', x) # x = 17.0
print('y =', y) # y = 1.0

