# -*- coding: utf-8 -*-
"""
 3. 연속형 변수 시각화 : 산점도, 히스토그램, 박스 플롯
"""

import matplotlib.pyplot as plt # 시각화
import numpy as np # 차트 자료  

# 음수 부호 지원 
import matplotlib
matplotlib.rcParams['axes.unicode_minus'] = False

# 차트 자료  
data1 = np.arange(-3, 7) # range(start, step) 
data2 = np.random.randn(10) # N(0,1)
print(data1)
print(data2)

# 3. 연속형 변수 시각화 : 산점도, 히스토그램, 박스 플롯
 
# 1) 산점도 
plt.scatter(x=data1, y=data2, c='r', marker='o')
plt.title('scatter function')
plt.show()

# 여러가지 색 산점도 
cdata = np.random.randint(1, 4, 10) # 1~3 난수 정수 
cdata # [3, 1, 3, 2, 1, 1, 1, 3, 1, 2]
plt.scatter(x=data1, y=data2, c=cdata, marker='o')
plt.title('scatter function')
plt.show()

# 2) 히스토그램
data3 = np.random.normal(0, 1, 2000)# N(mean, sigma^2)
print(data3) # 표준정규분포 난수 

data4 = np.random.normal(0, 1, 2000)# N(mean, sigma^2)
print(data4) # 표준정규분포 난수 


# 난수 통계
print(data3.mean()) # 0.026929031729268856
print(data3.std()) # 0.9955193254030043

print(data4.mean()) # 0.026929031729268856
print(data4.std()) # 0.9955193254030043

# 정규분포 시각화 
plt.hist(data3, bins=100, density=True, histtype='step', label = 'data3')
plt.hist(data4, bins=100, density=True, histtype='step', label = 'data4')
plt.legend(loc='best') 
plt.show()
'''
loc 속성값  
lower left
center left
upper left
lower right
center right
upper right 
'''


# 3) 상자 그래프(box plot) 
data5 = np.random.random(100)

# 난수 통계
print(data5.min()) # 0.00585566243621316
print(data5.max()) # 0.9944362796158128

# 요약통계량  
import pandas as pd
series = pd.Series(data5)
print(series.describe())
'''
count    100.000000
mean       0.487122
std        0.318326
min        0.000793
25%        0.189389
50%        0.459716
75%        0.762425
max        0.999693
'''

plt.boxplot(data5) # boxlpot
plt.show()

