'''
marker, color, line style, label 이용 
'''

import matplotlib.pyplot as plt
import numpy as np
plt.style.use('ggplot') # 차트 격차 제공 

# 1) data 생성 : 표준정규분포 * 표준편차 + 평균
data1 = 0.5 + 0.3 * np.random.randn(100)
data2 = 0.7 + 0.2 * np.random.randn(100)
data3 = 0.9 + 0.1 * np.random.randn(100)
data4 = 0.3 + 0.4 * np.random.randn(100)

# 2) Figure 객체 
fig = plt.figure(figsize = (12, 5)) # 차트 크기 : 12x5

# 3) add_subplot()
chart = fig.add_subplot() # subplot 추가 

# 4) plot()
chart.plot(data1, marker=r'o', color=u'blue', linestyle='-', label='Blue Solid')
chart.plot(data2, marker=r'+', color=u'red', linestyle='--', label='Red Dashed')
chart.plot(data3, marker=r'*', color=u'green', linestyle='-.', label='Green Dash Dot')
chart.plot(data4, marker=r's', color=u'orange', linestyle=':', label='Orange Dotted')

# 5) title, label, legend
chart.set_title('Line Plots: Markers, Colors, and Line styles')
plt.xlabel('index')
plt.ylabel('Random Number')
plt.legend(loc='best')
plt.show()










