# -*- coding: utf-8 -*-
"""
Pandas 객체 시각화 
 형식) object.plot(kind='차트유형', 속성); plt.show() 
 object : Series(1차원), DataFrame(2차원) 
 kind = bar, pie, hist, kde, scatter, box 등 
"""

import pandas as pd # object
import numpy as np # dataset 
import matplotlib.pyplot as plt # chart

# 1. 기본 차트 시각화 

# 1) Series 객체 시각화 
ser = pd.Series(np.random.randn(10),
                index = np.arange(0, 100, 10)) # 1차원 
print(ser)

# 기본차트 : 선 그래프 
ser.plot(color='g')
plt.show()

# 2) DataFrame 객체 시각화 
df = pd.DataFrame(np.random.randn(10, 4),
             columns=('one','two','three','fore'))
print(df)

help(df.plot)

# 기본차트 : 선 그래프 
df.plot()
plt.show()

# 막대차트 : 세로  
df.plot(kind = 'bar', title = 'bar chart')
plt.show()

# 막대차트 : 가로  
df.plot(kind = 'barh', title = 'barh chart')
plt.show()

# 가로막대, 누적형 
df.plot(kind = 'barh', title = 'barh chart', stacked=True)
plt.show()



