# -*- coding: utf-8 -*-
"""
Pandas 객체 시각화 
 형식) object.plot(kind='차트유형', 속성); plt.show() 
 object : Series(1차원), DataFrame(2차원) 
 kind = bar, pie, hist, kde, scatter, box 등 
"""

import pandas as pd # object
import numpy as np # dataset 
import matplotlib.pyplot as plt # chart


# 2. 커널밀도추정(kde)

# 1) DataFrame 객체 
df = pd.DataFrame(np.random.randn(10, 4),
               columns=('one','two','three','fore'))
print(df)

# 2) 히스토그램
df['one'].plot(kind = 'hist', title = 'histogram')
plt.show()

# 3) 커널밀도추정 : 히스토그램 -> 확률밀도분포곡선 
df['one'].plot(kind = 'kde', title='kernel density plot')
plt.show()

# 전체 칼럼 대상 
df.plot(kind = 'kde', title='kernel density plot')
plt.show()

# 4) 박스플롯
df.plot(kind='box', title='boxplot chart')
plt.show()

