# -*- coding: utf-8 -*-
"""
Pandas 객체 시각화 
 형식) object.plot(kind='차트유형', 속성); plt.show() 
 object : Series(1차원), DataFrame(2차원) 
 kind = bar, pie, hist, kde, scatter, box 등 
"""

import pandas as pd # object
import matplotlib.pyplot as plt # chart
import os

# 3. 산점도 행렬과 3차원 산점도

# iris.csv
os.chdir('C:/PythonAnalysis/data')
iris = pd.read_csv('iris.csv')
cols = list(iris.columns)

x = iris[cols[:4]]
print(x.head())

# 1) 산점도 matrix 
from pandas.plotting import scatter_matrix
scatter_matrix(x)
plt.show()


# 2) 3차원 산점도 
from mpl_toolkits.mplot3d import Axes3D

col_x = iris[cols[0]]
col_y = iris[cols[1]]
col_z = iris[cols[2]]

cdata = []
for s in iris['Species'] :
    if s == 'setosa' :
        cdata.append(1)
    elif s == 'versicolor' :
        cdata.append(2) 
    else :
        cdata.append(3)
        
print(cdata) 

fig = plt.figure()
chart = fig.add_subplot(projection='3d')

chart.scatter(col_x, col_y, col_z, c=cdata)
chart.set_xlabel('Sepal.Length')
chart.set_ylabel('Sepal.Width')
chart.set_zlabel('Petal.Length')
plt.show()






 
