
import matplotlib.pyplot as plt
import seaborn as sn

# 2. object형 vs category형

# dataset load 
tips = sn.load_dataset('tips')
titanic = sn.load_dataset('titanic')

# titanic 데이터셋 정보 
print(titanic.info()) 

# subset 만들기 
df = titanic[['survived','age','class','who']]
print(df.info())
print(df)
print(df.sort_values(by = 'class'))#category
print(df.sort_values(by = 'who'))#object

# category형 변환 
df['who_new'] = df['who'].astype('category')
print(df.info())

# 특정 칼럼으로 정렬 
print(df.sort_values(by = 'who_new'))#object
# "child" > "man" > "woman" 

# category 수정 
df['who_new'] = df['who_new'].cat.set_categories(['man','woman','child'])

print(df.sort_values(by = 'who_new'))#object
# "man" > "woman" > "child"


# 3. 범주형 자료 시각화 

# 1) 그래프 배경 스타일 
sn.set_style(style='darkgrid')
'''
그래프 배경 스타일  
style = “darkgrid”, “whitegrid”, “dark”, “white”, “ticks”
rc = [dict], 세부 사항을 조정함
'''

# 2) 범주형 자료 시각화 
sn.countplot(x='smoker', data=tips) # 2개 범주 
plt.title('smoker of tips') # 한글 지원 필요 
plt.show()


sn.countplot(x='class', data=titanic) # 3개 범주 
plt.title('class of titanic') # 한글 지원 필요 
plt.show()

sn.countplot(x='day', data=tips) # 4개 범주 
plt.title('day of tips') # 한글 지원 필요 
plt.show()







