
import matplotlib.pyplot as plt
import seaborn as sn


# dataset load 
iris = sn.load_dataset('iris')
tips = sn.load_dataset('tips')

# 4. 연속형 자료 시각화 

# 1) hist
x = iris.sepal_length
sn.hist(x)
plt.title('Sepal length hist')
plt.show()

# 2) distplot : 히스토그램 + 밀도분포 
sn.distplot(x, hist=True, kde=True)
plt.title('iris Sepal length hist & kde')
plt.show()
# kde : 커널밀도추정(kernel density estimation) 함수 이용 밀도분포 추정

# 3) scatter matrix 
#sn.pairplot(data=DataFrame, hue='집단변수', kind='scatter')
sn.pairplot(data=iris, hue='species')
plt.show()


# 4) 산점도 - 1차 : 연속형+연속형   
sn.scatterplot(x="sepal_length", y="petal_length",
               data=iris)
plt.show()

# 4) 산점도 - 2차 : 연속형+연속형+범주형(hue=집단변수) 
sn.scatterplot(x="sepal_length", y="petal_length",
             hue="species", data=iris)
plt.show()
 
# 5) 2개 연속형 변수의 통계적 관계 :연속형+연속형+범주형 
sn.relplot(x="total_bill", y="tip", size="size", 
           sizes=(15, 200), data=tips)
plt.show()
# 총지불 금액과 팁은 대체적으로 비례관계, 여기서 행사규모 변수 추가
# 행사규모가 큰 경우는 대체적으로 총지불금액이 크다. 

# seaborn 차트에서 한글 지원 
plt.rcParams['font.family'] = 'Malgun Gothic'

# 6) boxplot : 범주형+연속형=범주형
sn.boxplot(x="day", y="total_bill", hue="sex", data=tips)
plt.title("성별을 기준으로 요일별 총지불 금액")
plt.show()
# 전반적으로 남성이 여성에 비해서 지불금액이 많다. 
# 주말에는 비교적 여성의 지불금액이 많아진다.   