
import matplotlib.pyplot as plt
import seaborn as sn

# dataset 로드 
iris = sn.load_dataset('iris')
flights = sn.load_dataset('flights')
 

# 5. 통계모델 관련 시각화 

# 1) 오차대역폭을 갖는 시계열 : x:시간축, y:통계량 
sn.lineplot(x="year", y="passengers", data=flights)
plt.show() # 시간축에 따라서 비행기 탑승객 증가 추세 
# 월에 따라서 탑승객의 증가 or 감소 폭 

# hue 추가 : 월 단위 탑승객 추세 : 6~8월 단위 차이가 커짐 
sn.lineplot(x="year", y="passengers", hue='month',
             data=flights)
plt.show()   

# iris 
sn.lineplot(x="sepal_length", y="petal_length",
             hue="species", data=iris)
plt.show()


# 2) 선형회귀 : 산점도와 회귀선
sn.regplot(x="sepal_length", y="petal_length", 
           data=iris) # hue 사용 불가 
plt.show()


# 신뢰구간 : ci=None or ci=95(회귀선 추정의 신뢰구간)
sn.lmplot(x="sepal_length", y="petal_length", 
          data=iris, ci=95)

# hue 속성 : 꽃의 종별 서로 다른 회귀선 
sn.lmplot(x="sepal_length", y="petal_length",
              hue="species", data=iris)
# 산점도와 회귀선 그리고 신뢰구간(회귀선 취정의 신뢰구간)
 
# col 속성 : 꽃의 종별 서로 다른 플롯 
sn.lmplot(x="sepal_length", y="petal_length",
              hue="species", col="species",
              data=iris)

# label 추가 
g = sn.lmplot(x="sepal_length", y="petal_length",
              hue="species", data=iris)
g.set_axis_labels("Sepal length", "Petal length")


