'''
확률변수와 통계 
'''
import statistics as stat # 확률과 통계
import numpy as np # count_nonzero() 함수 제공  
import random # 난수 생성 
random.seed(123) # 난수 시드값 제공 
 

# 1. 동전을 10번 던져서 앞면(1) 또는 뒷면(0)이 나오는 실험
coin = [] # 확률변수 
for i in range(10) :
    r = random.randint(0, 1) # random.randrange(0, 4)
    coin.append(r)

print('확률변수 =', coin)
print('확률변수 평균 =', stat.mean(coin)) # 0.3
print('확률변수 최빈수 =', stat.mode(coin)) # 0
print('앞면(1) 개수 =', np.count_nonzero(coin))


# 2. 모집단에서 몸무게 65~85km 사이의 난수 100개 추출 
# 100개 균등분포 추출(몸무게 65~85km연속확률분포) : 몸무게 sampling
sample_height = [random.uniform(65, 85) for i in range(100)]
print(sample_height) # 균등분포 

print('몸무게 평균 =', stat.mean(sample_height))
print('중위수 =', stat.median(sample_height))
print('분산 =', stat.variance(sample_height))
print('표준편차 =', stat.stdev(sample_height))


# 3. 모집단에서 평균 175cm, 표준편차 5cm를 갖는 100개 추출
# (연속확률분포) : 키 sampling
# gauss(self, mu, sigma):
sample_data = [random.gauss(175, 5) for i in range(100)]
print(sample_data) # 정규분포 

print('키 평균 =', stat.mean(sample_data))
print('중위수 =', stat.median(sample_data))
print('분산 =', stat.variance(sample_data))
print('표준편차 =', stat.stdev(sample_data))
'''
키 평균 = 174.82000032138797
중위수 = 174.78999322248177
분산 = 23.16286129500235
표준편차 = 4.812781035430799
'''











