import numpy as np # 별칭 
import matplotlib.pyplot as plt # 그래프 

# 정규분포와 표준정규분포

# 1) 정규분포  : N(평균, 표준편차^2))
height = np.random.normal(173, 5, 2000) # N(173, 5^2)
print(height) # (2000,)

height2 = np.random.normal(173, 5, (500, 4))# N(173, 5^2)
print(height2) # (500, 4)


# 난수 통계
print(height.mean()) # 173.64868062947306
print(height2.mean()) # 173.38566887645658

# 정규분포 시각화 
plt.hist(height, bins=100, density=True, histtype='step')
plt.show()


# 2) 표준정규분포 : N(0, 1)
standNormal = np.random.randn(500, 3)
print(standNormal.mean()) # -0.04444361993656145

# normal 함수 이용 
standNormal2 = np.random.normal(0, 1, (500, 3))
print(standNormal2.mean())


# 정규분포 시각화 
plt.hist(standNormal[:,0], 
         bins=100, density=True, histtype='step', label='col1')
plt.hist(standNormal[:,1], 
         bins=100, density=True, histtype='step', label='col2')
plt.hist(standNormal[:,2], 
         bins=100, density=True, histtype='step',label='col3')
plt.legend(loc='best')
plt.show()






