'''
t 검정 유형 
  3. 대응표본 T검정(대응 두 집단 평균차이검정)
'''

from scipy import stats # test
import numpy as np # sampling


# 3. 대응표본 T검정 

# 1) 표본추출  
before = np.random.randint(69, 74,  size=30) 
after = np.random.randint(70, 75, size=30)  

print('교수법 적용 전 실기 점수')
print(before )
print('교육법 적용 후 점수')
print(after )

# 2) 동질성 검정 : H0 : 집단 간의 분포는 동일하다.
statistic, pvalue = stats.levene(before, after)
print('동질성 검정통계량 = %.3f, pvalue = %.5f'%(statistic, pvalue))

# 3) T검정 : 대응 두 집단 평균차이검정 
statistic, pvalue = stats.ttest_rel(before, after)
print('t검정 통계량 = %.5f, pvalue = %.5f'%(statistic, pvalue))

# 유의확률과 유의수준 비교 
alpha = 0.05
if pvalue >=  alpha:
    print('귀무가설(H0) 채택')
else : 
    print('대립가설(H1) 채택')
    
# 대립가설(H1) 채택
# [해설] 여성 집단의 점수와 남성 집단의 점수의 평균 차이가 없다.

# 4) 기술통계 
print('교수법 적용 전 평균 점수 =', before.mean()) 
print('교수법 적용 후 평균 점수 =', after.mean())
'''
교육방법1의 평균 점수 = 78.05087119776154
교육방법2의 평균 점수 = 73.39100302578092
'''
