# -*- coding: utf-8 -*-
from scipy import stats #levene, f_oneway
import matplotlib.pyplot as plt # 요약통계량 시각화  
import numpy as np 

## 1. 일원분산분석 

# 1) 표본추출  
method1 = np.random.randint(50, 100, size=50) 
method2 = np.random.randint(52, 95, size=50)  
method3 = np.random.randint(55, 99, size=50)


# 2) 동질성 검정 : H0 : 집단 간의 분포는 동일하다. 
statistic, pvalue = stats.levene(method1, method2, method3)
print('동질성 검정통계량 = %.3f, pvalue = %.5f'%(statistic, pvalue))

# 상자그래프 시각화 : 요약통계량 시각화 
plot_data = [method1, method2, method3]
ax = plt.boxplot(plot_data)
plt.show() # 집단별 약간의 평균에 차이가 있음 


# 3) F검정 : 일원분산분석
statistic, pvalue = stats.f_oneway(method1, method2, method3)
print('F검정 검정통계량 = %.5f, pvalue = %.5f'%(statistic, pvalue))

# 유의확률과 유의수준 비교 
alpha = 0.05
if pvalue >=  alpha:
    print('귀무가설(H0) 채택 : 집단별 평균에 차이가 없음')
else : 
    print('대립가설(H1) 채택 : 적어도 한 집단에서 평균에 차이가 있음')
'''    
F검정 통계량 = 1.52428, pvalue = 0.22120
귀무가설(H0) 채택 : 집단별 평균에 차이가 없음
'''

# 4) 기술통계 
print('교육방법1의 평균 점수 =', method1.mean()) 
print('교육방법2의 평균 점수 =', method2.mean())
print('교육방법3의 평균 점수 =', method3.mean()) 
'''
교육방법1의 평균 점수 = 75.08
교육방법2의 평균 점수 = 72.94
교육방법3의 평균 점수 = 77.52
'''
